/*
 * Copyright 2006, 2007 by Paul Mattes.
 *   Permission to use, copy, modify, and distribute this software and its
 *   documentation for any purpose and without fee is hereby granted,
 *   provided that the above copyright notice appear in all copies and that
 *   both that copyright notice and this permission notice appear in
 *   supporting documentation.
 *
 * wc3270 is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the file LICENSE for more details.
 */

// wc3270wiz.cpp : main project file.

#include "stdafx.h"
#include "Form1.h"

// Explicit definitions of the GUIDs used by IShellLink.
// For reasons known only to MS, the linker can't find these in
// uuid.lib.
#include <initguid.h>
#include <shlguid.h>
DEFINE_SHLGUID(CLSID_ShellLink, 0x00021401L, 0, 0);
DEFINE_SHLGUID(IID_IShellLinkW, 0x000214F9L, 0, 0);
DEFINE_GUID(IID_IShellLinkDataList, 0x45e2b4ae, 0xb1c3, 0x11d0, 0xb9, 0x2f, 0x0, 0xa0, 0xc9, 0x3, 0x12, 0xe1);
DEFINE_GUID(IID_IPersistFile,0x10b,0,0,0xc0,0,0,0,0,0,0,0x46);

using namespace wc3270wiz;

[STAThreadAttribute]
int main(array<System::String ^> ^args)
{
	// Enabling Windows XP visual effects before any controls are created
	Application::EnableVisualStyles();
	Application::SetCompatibleTextRenderingDefault(false); 

	// Create the main window and run it
	Application::Run(gcnew Form1());
	return 0;
}

// Link creation function
void CreateLink(
	int *result,
	System::String ^profile_name,
	System::String ^model)
{
	*result = 0;
	HRESULT hres;
    int initialized;
    IShellLink *psl = NULL;
    IShellLinkDataList *psldl = NULL;
    IPersistFile *ppf = NULL;
    NT_CONSOLE_PROPS p;
    wchar_t wsz[MAX_PATH];
	char args[MAX_PATH];
	char linkpath[MAX_PATH];
	char userprofile[MAX_PATH];
	size_t uplen;

    hres = CoInitialize(NULL);
    if (!SUCCEEDED(hres))
		goto out;
    initialized = 1;

    // Get a pointer to the IShellLink interface.
    hres = CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER,
        IID_IShellLink, (LPVOID *)&psl);

    if (!SUCCEEDED(hres))
		goto out;

	/* Figure out where the desktop is. */
	hres = getenv_s(&uplen, userprofile, MAX_PATH, "USERPROFILE");
	if (hres != 0 || uplen == 0) {
		if (hres == 0)
			hres = 1;
			goto out;
    }
    sprintf_s(linkpath, MAX_PATH, "%s\\Desktop\\%s.lnk", userprofile,
		profile_name);

    // Set the path to the shortcut target, and add the description.
	MultiByteToWideChar(CP_ACP, 0, "C:\\Program Files\\wc3270\\wc3270.exe", -1, wsz, MAX_PATH);
	psl->SetPath(wsz);
	MultiByteToWideChar(CP_ACP, 0, "", -1, wsz, MAX_PATH);
    psl->SetDescription(wsz);
	sprintf_s(args, MAX_PATH, "\"%s.wc3270\"", profile_name);
	MultiByteToWideChar(CP_ACP, 0, args, -1, wsz, MAX_PATH);
    psl->SetArguments(wsz);
	MultiByteToWideChar(CP_ACP, 0, "C:\\Program Files\\wc3270", -1, wsz, MAX_PATH);
	psl->SetWorkingDirectory(wsz);

    hres = psl->QueryInterface(IID_IShellLinkDataList,
    (void **)&psldl);
    if (!SUCCEEDED(hres))
		goto out;

	int cols;
	int rows;
	switch(model[0] - L'0') {
		default:
		case 2:
			cols = 80;
			rows = 25;
			break;
		case 3:
			cols = 80;
			rows = 33;
			break;
		case 4:
			cols = 80;
			rows = 44;
			break;
		case 5:
			cols = 132;
			rows = 28;
			break;
	}
    memset(&p, '\0', sizeof(NT_CONSOLE_PROPS));
    p.dbh.cbSize = sizeof(p);
    p.dbh.dwSignature = NT_CONSOLE_PROPS_SIG;
    p.wFillAttribute = 7;   /* ? */
    p.wPopupFillAttribute = 245;    /* ? */
    p.dwScreenBufferSize.X = cols;
    p.dwScreenBufferSize.Y = 0x012c;
    p.dwWindowSize.X = cols;
    p.dwWindowSize.Y = rows;
    p.dwWindowOrigin.X = 0;
    p.dwWindowOrigin.Y = 0;
    p.dwWindowOrigin.Y = 0;
    p.nFont = 0;
    p.nInputBufferSize = 0;
    p.dwFontSize.X = 0;
    p.dwFontSize.Y = 0;
    p.uFontFamily = 54; /* ? */
    p.uFontWeight = 400; /* ? */
	wcscpy_s(p.FaceName, LF_FACESIZE, L"Lucida Console");
    p.uCursorSize = 0x19;
    p.bFullScreen = 0;
    p.bQuickEdit = 0;
    p.bInsertMode = 1;
    p.bAutoPosition = 1;
    p.uHistoryBufferSize = 0x32;
    p.uNumberOfHistoryBuffers = 4;
    p.bHistoryNoDup = 0;
    p.ColorTable[0] = 0;
    p.ColorTable[1] =  0x00800000;
    p.ColorTable[2] =  0x00008000;
    p.ColorTable[3] =  0x00808000;
    p.ColorTable[4] =  0x00000080;
    p.ColorTable[5] =  0x00800080;
    p.ColorTable[6] =  0x00008080;
    p.ColorTable[7] =  0x00c0c0c0;
    p.ColorTable[8] =  0x00808080;
    p.ColorTable[9] =  0x00ff0000;
    p.ColorTable[10] = 0x0000ff00;
    p.ColorTable[11] = 0x00ffff00;
    p.ColorTable[12] = 0x000000ff;
    p.ColorTable[13] = 0x00ff00ff;
    p.ColorTable[14] = 0x0000ffff;
    p.ColorTable[15] = 0x00ffffff;

    hres = psldl->AddDataBlock(&p);
    if (!SUCCEEDED(hres))
		goto out;

    // Query IShellLink for the IPersistFile interface for saving
    // the shortcut in persistent storage.
    hres = psl->QueryInterface(IID_IPersistFile,
        (void **)&ppf);

    if (!SUCCEEDED(hres))
		goto out;

    // Ensure that the string is ANSI.
    MultiByteToWideChar(CP_ACP, 0, linkpath, -1, wsz, MAX_PATH);
    // Save the link by calling IPersistFile::Save.
    hres = ppf->Save(wsz, TRUE);

out:
    if (ppf != NULL)
		ppf->Release();
    if (psldl != NULL)
		psldl->Release();
    if (psl != NULL)
		psl->Release();
    if (initialized)
		CoUninitialize();

	*result = hres;
}